<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Gérer mes groupes</h1>
    </mt-page-title>
    <mt-box padding="0">
      <header class="columns mt-box-header mt-header-borderless">
        <div class="column"></div>
        <div class="column is-narrow">
          <nuxt-link
            :to="profilLink({ name: 'pax-groupe-creer' })"
            class="mt-button button is-primary mt-button-fin is-size-7 has-text-weight-semibold"
          >
            Créer un groupe
          </nuxt-link>
        </div>
      </header>
      <article class="mt-box-content">
        <mt-list v-slot="{ item: groupe }" :list="groupes">
          <mt-list-item>
            <div class="columns is-vcentered is-mobile">
              <div class="columns column is-vcentered">
                <div class="column is-clickable" @click="openDetailsGroupe(groupe)">
                  {{ groupe.nom }}
                </div>
                <div class="column is-narrow action-buttons">
                  <nuxt-link :to="profilLink({ name: 'pax-groupe-id-editer', params: { id: groupe.id } })">
                    <b-button
                      type="is-text"
                      class="mt-button-action-on-hover"
                      icon-left="account-plus"
                      title="Éditer le groupe"
                    >
                    </b-button>
                  </nuxt-link>
                  <b-button
                    type="is-text"
                    class="mt-button-action-on-hover"
                    icon-left="delete"
                    title="Supprimer le groupe"
                    @click="openSupprimer(groupe)"
                  >
                  </b-button>
                </div>
                <div class="column is-narrow">
                  <mt-count-utilisateur :nombre="groupe.groupesPersonnaliserDetails.length"></mt-count-utilisateur>
                </div>
              </div>
            </div>
          </mt-list-item>
        </mt-list>
      </article>
    </mt-box>
    <mt-modal-action type-delete :ouvert.sync="ouvert" @action="supprimerGroupe">
      Êtes-vous certain(e) de vouloir supprimer le groupe <b>{{ groupeSelected.nom }}</b> ?
    </mt-modal-action>
    <mt-modal-ok :ouvert.sync="ouvertPopUpConfirmationSuppression">
      Le groupe a bien été supprimé.
    </mt-modal-ok>
    <mt-modal-ok :ouvert.sync="ouvertDetailsGroupe" message-expanded class-modal="mt-font-weight">
      <div class="columns is-mobile is-vcentered margin">
        <div class="column">
          <b-field>
            <b-input
              class="mt-auto-complete-border-less"
              placeholder="Rechercher une personne"
              icon="magnify"
              @input="search"
            ></b-input>
          </b-field>
        </div>
        <div class="column is-narrow">
          <mt-count-utilisateur :nombre="filtreUtilisateurs.fullsize"></mt-count-utilisateur>
        </div>
      </div>
      <mt-filtre-categorie
        :fullsize="filtreUtilisateurs.fullsize"
        :categories="filtreUtilisateurs.corps"
        @select-all="viderFiltre"
        @select-categorie="filtreCategorie"
      >
      </mt-filtre-categorie>
      <mt-list v-slot="{ item: utilisateur }" :list="filtreUtilisateurs.filtrer">
        <mt-list-item :name="`utilisateur-${utilisateur.id}`">
          <mt-utilisateur :utilisateur="utilisateur"><b-icon v-if="!utilisateur.enabled" icon="lock"/></mt-utilisateur>
        </mt-list-item>
      </mt-list>
      <template #buttons
        ><span><!--pas de bouton--></span></template
      >
    </mt-modal-ok>
  </main>
</template>

<script>
import debounce from 'lodash/debounce';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import userMixin from '~/components/mixins/userMixin';
import MtCountUtilisateur from '~/components/pax/mt-count-utilisateur';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtModalOk from '~/components/modal/mt-modal-ok';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  components: {
    MtUtilisateur,
    MtFiltreCategorie,
    MtModalOk,
    MtModalAction,
    MtCountUtilisateur,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
  },
  mixins: [userMixin],
  data() {
    return {
      filtre: '',
      isFetching: false,
      selected: null,
      data: [],
      ouvert: false,
      utilisateurSelected: {},
      organismes: [],
      groupeSelected: {},
      ouvertPopUpConfirmationSuppression: false,
      ouvertDetailsGroupe: false,
      filtreUtilisateurs: [],
      idCorps: null,
    };
  },
  async asyncData({ $api }) {
    const groupes = await $api.utilisateur().groupes();
    return {
      groupes,
    };
  },
  methods: {
    async openDetailsGroupe(groupe) {
      this.groupeSelected = groupe;
      this.filtreUtilisateurs = await this.$api.groupePersonnaliser.utilisateurs(this.groupeSelected.id);
      this.ouvertDetailsGroupe = true;
    },
    selectAutoComplete(option) {
      this.selected = option;
    },
    async refresh() {
      this.filtreUtilisateurs = await this.$api.groupePersonnaliser.utilisateurs(this.groupeSelected.id, this.idCorps);
    },
    filtreCategorie(corps) {
      this.idCorps = corps.id;
      this.refresh();
    },
    viderFiltre() {
      this.idCorps = null;
      this.refresh();
    },
    openSupprimer(groupe) {
      this.groupeSelected = groupe;
      this.ouvert = true;
    },
    async supprimerGroupe() {
      await this.$api.groupePersonnaliser.delete(this.groupeSelected.id);
      await this.$store.dispatch('context/setGroupesSelected', []);
      this.groupes = await this.$api.utilisateur().groupes();
      this.ouvert = false;
      this.groupeSelected = {};
      this.ouvertPopUpConfirmationSuppression = true;
    },
    search: debounce(async function getAsyncData(search) {
      this.isFetching = true;
      try {
        this.filtreUtilisateurs = await this.$api.groupePersonnaliser.utilisateurs(
          this.groupeSelected.id,
          this.idCorps,
          search,
        );
      } catch (e) {
        this.$buefy.toast.open({
          message: 'Une erreur est survenue lors de la récupération des données.',
          type: 'is-danger',
        });
      } finally {
        this.isFetching = false;
      }
    }, 300),
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-filter-liste {
  display: flex;
  justify-content: space-between;
  margin-top: 1rem;
  .mt-filter-liste-groupe {
    display: flex;
  }

  /deep/ .mt-filter-item {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;

    &.selected,
    &.selected:hover {
      background-color: $periwinkle-blue;
      color: $white;
    }
  }
}
.link {
  font-weight: bold;
  color: $soft-blue;
  &:hover {
    color: $periwinkle-blue;
  }
}
/deep/ .mt-auto-complete-border-less {
  input {
    border-style: none;
    box-shadow: none;
  }
}
.is-clickable:hover {
  color: $black;
  cursor: pointer;
}
/deep/ .mt-modal .mt-list {
  height: 40vh;
  overflow-y: auto;
  scrollbar-width: thin;
}
/deep/ .mt-font-weight {
  .mt-modal-message .mt-filter-item {
    font-weight: 400;
  }

  .mt-modal-message .mt-utilisateur {
    font-weight: 400;
  }
}
</style>
